<template>
    <div class="app-container calendar-list-container exchangeView" v-loading="loading" element-loading-text="数据生成中">
        <!-- 查询和其他操作 -->
        <div class="filter-container">
            <el-input clearable class="filter-item" style="width: 200px" placeholder="勋章名称"
                v-model="listQuery.name"></el-input>
            <el-input clearable class="filter-item" style="width: 200px" placeholder="勋章类型"
                v-model="listQuery.type"></el-input>
            <el-select v-model="listQuery.status" clearable placeholder="状态" style="top: -4px; width: 200px">
                <el-option :key="item.dictValue" v-for="item in statusList" :label="item.dictLabel" :value="item.dictValue">
                </el-option>
            </el-select>
            <el-button class="filter-item" type="primary" v-waves icon="el-icon-search" @click="handleFilter">查找</el-button>
            <el-button class="filter-item" type="primary" @click="handleCreate" icon="el-icon-edit">添加</el-button>
            <el-button class="filter-item" type="primary" icon="el-icon-refresh" @click="handleRefresh">立即生成</el-button>
            <el-button class="filter-item" type="warning" icon="el-icon-delete" @click="delAll">批量删除</el-button>
            
        </div>

        <!-- 查询结果 -->
        <el-table size="small" :data="list" @selection-change="handleSelectionChange" v-loading="listLoading"
            element-loading-text="正在查询中。。。" border fit highlight-current-row>
            <el-table-column type="selection" width="55px"> </el-table-column>
            <el-table-column type="index" label="序号" header-align="center" align="center">
            </el-table-column>
            <el-table-column align="center" min-width="80px" label="勋章名称" prop="name">
            </el-table-column>
            <el-table-column align="center" min-width="80px" label="勋章类型" prop="type">
                <template slot-scope="scope">
                    <router-link :to="{ name: 'medalDataList', params: { id: scope.row.type } }">
                        <div style="color: #337ab7; cursor: pointer">
                            {{ scope.row.type }}
                        </div>
                    </router-link>
                </template>
            </el-table-column>
            <el-table-column align="center" min-width="80px" label="状态" prop="statusName">
            </el-table-column>
            <el-table-column align="center" min-width="80px" label="排序" prop="sort">
            </el-table-column>
            <el-table-column align="center" min-width="150px" label="创建时间" prop="createTime">
            </el-table-column>
            <el-table-column align="center" label="操作" width="240px" class-name="small-padding fixed-width">
                <template slot-scope="scope">
                    <el-button type="primary" size="small" @click="handleUpdate(scope.row)">编辑</el-button>
                    <el-button type="danger" size="small" @click="handleDelete(scope.row)">删除</el-button>
                </template>
            </el-table-column>
        </el-table>

        <!-- 分页 -->
        <div class="pagination-container">
            <el-pagination background @size-change="handleSizeChange" @current-change="handleCurrentChange"
                :current-page="listQuery.page" :page-sizes="[10, 20, 30, 50]" :page-size="listQuery.limit"
                layout="total, sizes, prev, pager, next, jumper" :total="total">
            </el-pagination>
        </div>
        <!-- 添加或修改对话框 -->
        <el-dialog :close-on-click-modal="false" :title="textMap[dialogStatus]" :visible.sync="dialogFormVisible"
            width="40%">
            <el-form :rules="rules" ref="dataForm" :model="dataForm" status-icon label-position="left" label-width="80px"
                style="width: 700px; margin-left: 50px">
                <el-form-item label="勋章名称" prop="name">
                    <el-input v-model="dataForm.name" style="width: 330px"></el-input>
                </el-form-item>
                <el-form-item label="勋章类型" prop="type">
                    <el-input v-model="dataForm.type" style="width: 330px"></el-input>
                </el-form-item>
                <el-form-item label="状态" prop="status">
                    <el-radio-group v-model="dataForm.status">
                        <el-radio v-for="item in statusList" :key="item.dictValue" :label="item.dictValue">{{ item.dictLabel
                        }}</el-radio>
                    </el-radio-group>
                </el-form-item>
                <el-form-item label="排序" prop="sort">
                    <el-input-number :precision="0" :step="1" v-model="dataForm.sort"></el-input-number>
                </el-form-item>
            </el-form>
            <div slot="footer" class="dialog-footer">
                <el-button @click="dialogFormVisible = false">取消</el-button>
                <el-button v-if="dialogStatus == 'create'" type="primary" @click="createData">确定</el-button>
                <el-button v-else type="primary" @click="updateData">确定</el-button>
            </div>
        </el-dialog>
    </div>
</template>
  
<style>
.avatar-uploader .el-upload {
    border: 1px dashed #d9d9d9;
    border-radius: 6px;
    cursor: pointer;
    position: relative;
    overflow: hidden;
}

.avatar-uploader .el-upload:hover {
    border-color: #409eff;
}

.avatar-uploader-icon {
    font-size: 28px;
    color: #8c939d;
    width: 80px;
    height: 80px;
    line-height: 80px;
    text-align: center;
}

.avatar {
    width: 80px;
    height: 80px;
    display: block;
}

.demo-table-expand {
    font-size: 0;
}

.demo-table-expand label {
    width: 200px;
    color: #99a9bf;
}

.demo-table-expand .el-form-item {
    margin-right: 0;
    margin-bottom: 0;
}
</style>
  
<script>
import {
    list,
    updateItem,
    createItem,
    deleteitem,
    refresh,
} from "@/api/medalList";
import { dataTypeList } from "@/api/public";
import waves from "@/directive/waves"; // 水波纹指令
import Tinymce from "@/components/Tinymce";

export default {
    components: { Tinymce },
    directives: { waves },
    data() {
        return {
            loading: false,
            rules: {
                name: [
                    { required: true, message: "勋章名称不能为空", trigger: "blur" },
                ],
                type: [
                    { required: true, message: "勋章名称不能为空", trigger: "blur" },
                ],
                status: [
                    { required: true, message: "请选择勋章状态", trigger: "blur" },
                ],
                sort: [{ required: true, message: "排序不能为空", trigger: "blur" }],
            },
            dialogStatus: "",
            textMap: {
                update: "编辑",
                create: "创建",
            },
            dialogFormVisible: false,
            dataForm: {
                name: "",
                type: "",
                status: "",
                sort: "",
            },
            statusList: [],
            list: [],
            total: 0,
            listLoading: false,
            listQuery: {
                page: 1,
                limit: 10,
                name: "",
                type: "",
                status: "",
            },
        };
    },
    created() {
        this.getStatusList();
        this.getList();
    },
    methods: {
        handleRefresh() {
            this.loading = true;
            refresh().then((response) => {
                this.$notify({
                    title: "成功",
                    message: "操作成功",
                    type: "success",
                    duration: 2000,
                });
                this.loading = false;
            });
        },
        resetForm() {
            this.dataForm = {
                name: "",
                type: "",
                status: "",
                sort: "",
            };
        },
        handleCreate() {
            this.resetForm();
            this.dialogFormVisible = true;
            this.dialogStatus = "create";
            this.$nextTick(() => {
                this.$refs["dataForm"].clearValidate();
            });
        },
        createData() {
            this.$refs["dataForm"].validate((valid) => {
                if (valid) {
                    createItem(this.dataForm).then(() => {
                        this.getList();
                        this.dialogFormVisible = false;

                        this.$notify({
                            title: "成功",
                            message: "创建成功",
                            type: "success",
                            duration: 2000,
                        });
                        this.getList();
                    });
                }
            });
        },
        getStatusList() {
            dataTypeList({ dictType: "medal_status_option_select" })
                .then((response) => {
                    this.statusList = response.data.data;
                })
                .catch(() => { });
        },
        getList() {
            this.listLoading = true;
            list(this.listQuery)
                .then((response) => {
                    this.list = response.data.data.items;
                    this.total = response.data.data.total;
                    this.listLoading = false;
                })
                .catch(() => { });
        },
        handleFilter() {
            this.listQuery.page = 1;
            this.getList();
        },
        handleSizeChange(val) {
            this.listQuery.limit = val;
            this.getList();
        },
        handleCurrentChange(val) {
            this.listQuery.page = val;
            this.getList();
        },
        handleUpdate(row) {
            this.dataForm = Object.assign({}, row);
            this.dialogStatus = "update";
            this.dialogFormVisible = true;
            this.$nextTick(() => {
                this.$refs["dataForm"].clearValidate();
            });
        },

        updateData() {
            this.$refs["dataForm"].validate((valid) => {
                if (valid) {
                    updateItem(this.dataForm).then(() => {
                        this.dialogFormVisible = false;
                        this.$notify({
                            title: "成功",
                            message: "更新成功",
                            type: "success",
                            duration: 2000,
                        });
                        this.getList();
                    });
                }
            });
        },

        handleDelete(row) {
            this.$confirm("确认删除吗?", "提示", {
                confirmButtonText: "确定",
                cancelButtonText: "取消",
                type: "warning",
            })
                .then(() => {
                    deleteitem({ ids: row.id }).then((response) => {
                        this.$notify({
                            title: "成功",
                            message: "删除成功",
                            type: "success",
                            duration: 2000,
                        });
                        this.getList();
                    });
                })
                .catch(() => { });
        },
        delAll() {
            this.$confirm("确认删除吗?", "提示", {
                confirmButtonText: "确定",
                cancelButtonText: "取消",
                type: "warning",
            })
                .then(() => {
                    const length = this.multipleSelection.length;

                    if (length > 0) {
                        for (let i = 0; i < length; i++) {
                            this.delarr.push(this.multipleSelection[i].id);
                        }
                        const dictIds = this.delarr.join(",");
                        deleteitem({ ids: dictIds })
                            .then(() => {
                                this.$notify({
                                    title: "成功",
                                    message: "删除成功",
                                    type: "success",
                                    duration: 2000,
                                });
                                this.getList();
                            })
                            .catch(() => { });
                    } else {
                        this.$notify({
                            title: "警告提示",
                            message: "请选择要删除的信息！",
                            type: "warning",
                        });
                    }
                })
                .catch(() => { });
        },
        handleSelectionChange(val) {
            this.multipleSelection = val;
        },
    },
};
</script>
<style>
.ad-avatar-uploader .el-upload {
    border: 1px dashed #d9d9d9;
    border-radius: 6px;
    cursor: pointer;
    position: relative;
    overflow: hidden;
}

.ad-avatar-uploader .el-upload:hover {
    border-color: #409eff;
}

.ad-avatar-uploader-icon {
    font-size: 28px;
    color: #8c939d;
    width: 178px;
    height: 178px;
    line-height: 178px;
    text-align: center;
}

.ad-avatar {
    display: block;
}

.exchangeView .el-dialog__body {
    padding-top: 0px;
}
</style>
  